diff --git a/imap/command.c b/imap/command.c
index 34793ccfb5..3bc4538eaf 100644
--- a/imap/command.c
+++ b/imap/command.c
@@ -213,7 +213,7 @@ static int cmd_start(struct ImapData *idata, const char *cmdstr, int flags)
 
   rc = mutt_socket_write_d(idata->conn, idata->cmdbuf.data, -1,
                            flags & IMAP_CMD_PASS ? IMAP_LOG_PASS : IMAP_LOG_CMD);
-  idata->cmdbuf.dptr = idata->cmdbuf.data;
+  mutt_buffer_rewind(&idata->cmdbuf);
 
   /* unidle when command queue is flushed */
   if (idata->state == IMAP_IDLE)
diff --git a/imap/imap.c b/imap/imap.c
index 81e4dc847e..d0d75a1de2 100644
--- a/imap/imap.c
+++ b/imap/imap.c
@@ -1239,7 +1239,7 @@ int imap_exec_msgset(struct ImapData *idata, const char *pre, const char *post,
 
   do
   {
-    cmd.dptr = cmd.data;
+    mutt_buffer_rewind(&cmd);
     mutt_buffer_printf(&cmd, "%s ", pre);
     rc = make_msg_set(idata, &cmd, flag, changed, invert, &pos);
     if (rc > 0)
diff --git a/muttlib.c b/muttlib.c
index 3ef5a01f0e..245ef83bd1 100644
--- a/muttlib.c
+++ b/muttlib.c
@@ -785,7 +785,7 @@ void mutt_expando_format(char *buf, size_t buflen, size_t col, int cols, const c
 
       /* prepare BUFFERs */
       mutt_buffer_from(&srcbuf, srccopy);
-      srcbuf.dptr = srcbuf.data;
+      mutt_buffer_rewind(&srcbuf);
 
       /* Iterate expansions across successive arguments */
       do
